drop table if exists mvnforumCategory;

drop table if exists mvnforumForum;

drop table if exists mvnforumGroupForum;

drop table if exists mvnforumGroupPermission;

drop table if exists mvnforumGroups;

drop table if exists mvnforumMember;

drop table if exists mvnforumMemberGroup;

drop table if exists mvnforumMemberPermission;

drop table if exists mvnforumMessageFolder;

drop table if exists mvnforumPost;

drop table if exists mvnforumThread;

create table if not exists mvnforumCategory
(
   CategoryID                     INT                            not null AUTO_INCREMENT,
   ParentCategoryID               INT                            not null,
   CategoryName                   varchar(250)                   not null,
   CategoryDesc                   TEXT                           not null,
   CategoryCreationDate           datetime                       not null,
   CategoryModifiedDate           datetime                       not null,
   CategoryOrder                  smallint                       not null,
   CategoryOption                 INT                            not null,
   CategoryStatus                 int                            not null,
   primary key (CategoryID),
   unique (CategoryName)
);

create table if not exists mvnforumForum
(
   ForumID                        INT                            not null AUTO_INCREMENT,
   CategoryID                     INT                            not null,
   LastPostMemberName             VARCHAR(30)                    not null,
   ForumName                      varchar(250)                   not null,
   ForumDesc                      TEXT                           not null,
   ForumCreationDate              datetime                       not null,
   ForumModifiedDate              datetime                       not null,
   ForumLastPostDate              datetime                       not null,
   ForumOrder                     smallint                       not null,
   ForumType                      INT                            not null,
   ForumFormatOption              INT                            not null,
   ForumOption                    INT                            not null,
   ForumStatus                    int                            not null,
   ForumModerationMode            INT                            not null,
   ForumPassword                  VARCHAR(40)                    not null,
   ForumThreadCount               INT                            not null,
   ForumPostCount                 INT                            not null,
   primary key (ForumID),
   unique (ForumName)
);

create index INDEX_2 on mvnforumForum
(
   CategoryID
);

create table if not exists mvnforumGroupForum
(
   GroupID                        INT                            not null,
   ForumID                        INT                            not null,
   Permission                     int                            not null,
   primary key (GroupID, ForumID, Permission)
);

create index INDEX_17 on mvnforumGroupForum
(
   GroupID
);

create index INDEX_18 on mvnforumGroupForum
(
   ForumID
);

create table if not exists mvnforumGroupPermission
(
   GroupID                        INT                            not null,
   Permission                     int                            not null,
   primary key (GroupID, Permission)
);

create index INDEX_19 on mvnforumGroupPermission
(
   GroupID
);

create table if not exists mvnforumGroups
(
   GroupID                        INT                            not null AUTO_INCREMENT,
   GroupOwnerID                   INT                            not null,
   GroupOwnerName                 VARCHAR(30)                    not null,
   GroupName                      varchar(250)                   not null,
   GroupDesc                      TEXT                           not null,
   GroupOption                    INT                            not null,
   GroupCreationDate              datetime                       not null,
   GroupModifiedDate              datetime                       not null,
   primary key (GroupID),
   unique (GroupName)
);

create table if not exists mvnforumMember
(
   MemberID                       INT                            not null AUTO_INCREMENT,
   MemberName                     VARCHAR(30)                    not null,
   MemberPassword                 VARCHAR(40)                    not null,
   MemberFirstEmail               VARCHAR(60)                    not null,
   MemberEmail                    VARCHAR(60)                    not null,
   MemberEmailVisible             BIT                            not null,
   MemberNameVisible              BIT                            not null,
   MemberFirstIP                  varchar(20)                    not null,
   MemberLastIP                   varchar(20)                    not null,
   MemberViewCount                INT                            not null,
   MemberPostCount                INT                            not null,
   MemberCreationDate             DATETIME                       not null,
   MemberModifiedDate             datetime                       not null,
   MemberLastLogon                datetime                       not null,
   MemberOption                   INT                            not null,
   MemberStatus                   int                            not null,
   MemberActivateCode             VARCHAR(40)                    not null,
   MemberTempPassword             VARCHAR(40)                    not null,
   MemberMessageCount             INT                            not null,
   MemberMessageOption            INT                            not null,
   MemberPostsPerPage             smallint                       not null,
   MemberWarnCount                smallint                       not null,
   MemberVoteCount                INT                            not null,
   MemberVoteTotalStars           INT                            not null,
   MemberRewardPoints             INT                            not null,
   MemberTitle                    varchar(250)                   not null,
   MemberTimeZone                 INT                            not null,
   MemberSignature                VARCHAR(250)                   not null,
   MemberAvatar                   VARCHAR(200)                   not null,
   MemberSkin                     VARCHAR(70)                    not null,
   MemberLanguage                 VARCHAR(70)                    not null,
   MemberFirstname                VARCHAR(70)                    not null,
   MemberLastname                 VARCHAR(70)                    not null,
   MemberGender                   BIT                            not null,
   MemberBirthday                 DATE                           not null,
   MemberAddress                  VARCHAR(150)                   not null,
   MemberCity                     VARCHAR(70)                    not null,
   MemberState                    VARCHAR(70)                    not null,
   MemberCountry                  VARCHAR(70)                    not null,
   MemberPhone                    VARCHAR(40)                    not null,
   MemberMobile                   VARCHAR(40)                    not null,
   MemberFax                      VARCHAR(40)                    not null,
   MemberCareer                   VARCHAR(50)                    not null,
   MemberHomepage                 VARCHAR(200)                   not null,
   MemberYahoo                    VARCHAR(70)                    not null,
   MemberAol                      VARCHAR(70)                    not null,
   MemberIcq                      VARCHAR(70)                    not null,
   MemberMsn                      VARCHAR(70)                    not null,
   MemberCoolLink1                VARCHAR(200)                   not null,
   MemberCoolLink2                VARCHAR(200)                   not null,
   primary key (MemberID),
   unique (MemberEmail),
   unique (MemberName)
);

create table if not exists mvnforumMemberGroup
(
   GroupID                        INT                            not null,
   MemberID                       INT                            not null,
   MemberName                     VARCHAR(30)                    not null,
   Privilege                      INT                            not null,
   CreationDate                   datetime                       not null,
   ModifiedDate                   datetime                       not null,
   primary key (GroupID, MemberID)
);

create index INDEX_20 on mvnforumMemberGroup
(
   MemberID
);

create index INDEX_21 on mvnforumMemberGroup
(
   GroupID
);

create table if not exists mvnforumMemberPermission
(
   MemberID                       INT                            not null,
   Permission                     int                            not null,
   primary key (MemberID, Permission)
);

create index INDEX_22 on mvnforumMemberPermission
(
   MemberID
);

create table if not exists mvnforumMessageFolder
(
   FolderName                     VARCHAR(30)                    not null,
   MemberID                       INT                            not null,
   FolderOrder                    smallint                       not null,
   FolderCreationDate             datetime                       not null,
   FolderModifiedDate             datetime                       not null,
   primary key (FolderName, MemberID)
);

create index INDEX_32 on mvnforumMessageFolder
(
   MemberID
);

create table if not exists mvnforumPost
(
   PostID                         INT                            not null AUTO_INCREMENT,
   ParentPostID                   INT                            not null,
   ForumID                        INT                            not null,
   ThreadID                       INT                            not null,
   MemberID                       INT                            not null,
   MemberName                     VARCHAR(30)                    not null,
   LastEditMemberName             VARCHAR(30)                    not null,
   PostTopic                      VARCHAR(250)                   not null,
   PostBody                       TEXT                           not null,
   PostCreationDate               datetime                       not null,
   PostLastEditDate               datetime                       not null,
   PostCreationIP                 varchar(20)                    not null,
   PostLastEditIP                 varchar(20)                    not null,
   PostEditCount                  smallint                       not null,
   PostFormatOption               INT                            not null,
   PostOption                     INT                            not null,
   PostStatus                     int                            not null,
   PostIcon                       VARCHAR(10)                    not null,
   PostAttachCount                smallint                       not null,
   primary key (PostID)
);

create index INDEX_7 on mvnforumPost
(
   ForumID
);

create index INDEX_8 on mvnforumPost
(
   ThreadID
);

create index INDEX_9 on mvnforumPost
(
   MemberID
);

create index INDEX_37 on mvnforumPost
(
   ParentPostID
);

create table if not exists mvnforumThread
(
   ThreadID                       INT                            not null AUTO_INCREMENT,
   ForumID                        INT                            not null,
   MemberName                     VARCHAR(30)                    not null,
   LastPostMemberName             VARCHAR(30)                    not null,
   ThreadTopic                    VARCHAR(250)                   not null,
   ThreadBody                     TEXT                           not null,
   ThreadVoteCount                INT                            not null,
   ThreadVoteTotalStars           INT                            not null,
   ThreadCreationDate             datetime                       not null,
   ThreadLastPostDate             datetime                       not null,
   ThreadType                     INT                            not null,
   ThreadOption                   INT                            not null,
   ThreadStatus                   int                            not null,
   ThreadHasPoll                  int                            not null,
   ThreadViewCount                int                            not null,
   ThreadReplyCount               int                            not null,
   ThreadIcon                     VARCHAR(10)                    not null,
   ThreadDuration                 INT                            not null,
   primary key (ThreadID)
);

create index INDEX_4 on mvnforumThread
(
   ForumID
);



#
# data for table 'mvnforumMember'
#
INSERT INTO mvnforumMember (MemberID, MemberName, MemberPassword, MemberFirstEmail, MemberEmail, MemberEmailVisible, MemberNameVisible, MemberFirstIP, MemberLastIP, MemberViewCount, MemberPostCount, MemberCreationDate, MemberModifiedDate, MemberLastLogon, MemberOption, MemberStatus, MemberActivateCode, MemberTempPassword, MemberMessageCount, MemberMessageOption, MemberPostsPerPage, MemberWarnCount, MemberVoteCount, MemberVoteTotalStars, MemberRewardPoints, MemberTitle, MemberTimeZone, MemberSignature, MemberAvatar, MemberSkin, MemberLanguage, MemberFirstname, MemberLastname, MemberGender, MemberBirthday, MemberAddress, MemberCity, MemberState, MemberCountry, MemberPhone, MemberMobile, MemberFax, MemberCareer, MemberHomepage, MemberYahoo, MemberAol, MemberIcq, MemberMsn, MemberCoolLink1, MemberCoolLink2)
	             VALUES("1", "Admin", "ISMvKXpXpadDiUoOSoAfww==", "admin@yourdomain.com", "admin@yourdomain.com", "0", "1",         "127.0.0.1",   "127.0.0.1",  "0",             "0",             now(),              now(),              now(),           "0",          "0",          "",                 "",                 "0",                "0",                 "10",               "0",             "0",             "0",                  "0",                "",          "0",            "",              "",           "",         "",             "",              "",             "1",          now(),          "",            "",         "",          "",            "",          "",           "",        "",           "",             "",          "",        "",        "",        "",              "");


#
# data for table 'mvnforumMessageFolder'
#
INSERT INTO mvnforumMessageFolder (FolderName, MemberID, FolderOrder, FolderCreationDate, FolderModifiedDate)
		   VALUES ("Inbox",    "1",      "0",         now(),              now());
INSERT INTO mvnforumMessageFolder (FolderName, MemberID, FolderOrder, FolderCreationDate, FolderModifiedDate)
		   VALUES ("Sent",     "1",      "0",         now(),              now());


#
# data for table 'mvnforumGroups'
#
INSERT INTO mvnforumGroups (GroupID, GroupOwnerID, GroupOwnerName, GroupName, GroupDesc,                                                GroupOption, GroupCreationDate, GroupModifiedDate)
             VALUES("1",     "0",          "",             "Guest",   "All anonymous users belong to this group.",              "0",         now(),             now());
INSERT INTO mvnforumGroups (GroupID, GroupOwnerID, GroupOwnerName, GroupName, GroupDesc,                                                GroupOption, GroupCreationDate, GroupModifiedDate)
             VALUES("2",     "0",          "",             "Member",  "All registered users belong to this group.",             "0",         now(),             now());
INSERT INTO mvnforumGroups (GroupID, GroupOwnerID, GroupOwnerName, GroupName, GroupDesc,                                                GroupOption, GroupCreationDate, GroupModifiedDate)
             VALUES("3",     "1",          "Admin",        "Admin",   "This group have SystemAdmin permission by default.",     "0",         now(),             now());
INSERT INTO mvnforumGroups (GroupID, GroupOwnerID, GroupOwnerName, GroupName, GroupDesc,                                                GroupOption, GroupCreationDate, GroupModifiedDate)
             VALUES("4",     "1",          "Admin",        "Forum Admin", "This group have ForumAdmin permission by default.",  "0",         now(),             now());
INSERT INTO mvnforumGroups (GroupID, GroupOwnerID, GroupOwnerName, GroupName, GroupDesc,                                                GroupOption, GroupCreationDate, GroupModifiedDate)
             VALUES("5",     "1",          "Admin",        "Forum Moderator", "This group have ForumModerator permission by default.","0",   now(),             now());


#
# data for table 'mvnforumMemberGroup'
#
INSERT INTO mvnforumMemberGroup (GroupID, MemberID, MemberName, Privilege, CreationDate, ModifiedDate)
                  VALUES("3",     "1",      "Admin",    "0",       now(),        now());



#
# data for table 'mvnforumMemberPermission'
#
INSERT INTO mvnforumMemberPermission (MemberID, Permission) 
		       VALUES("1",      "100");


#
# data for table 'mvnforumGroupPermission'
#
INSERT INTO mvnforumGroupPermission (GroupID, Permission) 
		      VALUES("1",     "109");
INSERT INTO mvnforumGroupPermission (GroupID, Permission) 
		      VALUES("2",     "110");
INSERT INTO mvnforumGroupPermission (GroupID, Permission) 
		      VALUES("3",     "100");
INSERT INTO mvnforumGroupPermission (GroupID, Permission) 
		      VALUES("4",     "105");
INSERT INTO mvnforumGroupPermission (GroupID, Permission) 
		      VALUES("5",     "106");

