/*
 * $Header: /cvsroot/mvnforum/mvnforum/src/net/myvietnam/mvnplugin/mvnforum/MyUtil.java,v 1.3 2002/12/06 19:04:30 minhnn Exp $
 * $Revision: 1.3 $
 * $Date: 2002/12/06 19:04:30 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding mvnForum
 * must remain intact in the scripts and in the outputted HTML
 * The "powered by" text/logo with a link back to
 * http://www.mvnForum.com and http://www.MyVietnam.net in the footer of the pages MUST
 * remain visible when the pages are viewed on the internet or intranet.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Support can be obtained from support forums at:
 * http://www.mvnForum.com/mvnforum/index
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvnplugin.mvnforum;

import javax.servlet.http.HttpServletRequest;
import net.myvietnam.mvncore.filter.*;
import net.myvietnam.mvncore.util.ParamUtil;

public class MyUtil {

    public static void prepareNavigate(HttpServletRequest request, int offset, int collectionSize, int totalRows, int rowsPerPage) {
        int startOffset = offset + 1;
        int lastOffset = offset + collectionSize;
        if (startOffset > lastOffset) startOffset = lastOffset;
        int previousOffset = -1;
        int nextOffset = -1;
        if (offset > 0) {
            previousOffset = offset - rowsPerPage;
            if (previousOffset < 0) previousOffset = 0;
        }
        if (lastOffset < totalRows) {
            nextOffset = offset + rowsPerPage;
        }
        request.setAttribute("StartOffset", new Integer(startOffset));
        request.setAttribute("LastOffset", new Integer(lastOffset));
        request.setAttribute("PreviousOffset", new Integer(previousOffset));
        request.setAttribute("NextOffset", new Integer(nextOffset));
    }

    public static String filter(String input, boolean enableHTML, boolean enableEmotion,
                                         boolean enableMVNCode, boolean enableNewLine) {
        String output = input;

        if (enableHTML) {
            //do nothing
        } else {
            output = DisableHtmlTagFilter.filter(output);
        }

        if (enableEmotion) {
            output = EnableEmotionFilter.filter(output, ParamUtil.getContextPath() + MVNForumGlobal.EMOTION_DIR);
        }

        if (enableMVNCode) {
            output = EnableMVNCodeFilter.filter(output);
        }

        if (enableNewLine) {
            output = HtmlNewLineFilter.filter(output);
        }

        return output;
    }
}