/*
 * $Header: /cvsroot/mvnforum/mvnforum/src/net/myvietnam/mvnplugin/mvnforum/auth/MVNForumPermissionFactory.java,v 1.3 2002/12/14 19:01:18 minhnn Exp $
 * $Revision: 1.3 $
 * $Date: 2002/12/14 19:01:18 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding mvnForum
 * must remain intact in the scripts and in the outputted HTML
 * The "powered by" text/logo with a link back to
 * http://www.mvnForum.com and http://www.MyVietnam.net in the footer of the pages MUST
 * remain visible when the pages are viewed on the internet or intranet.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Support can be obtained from support forums at:
 * http://www.mvnForum.com/mvnforum/index
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvnplugin.mvnforum.auth;

import java.util.ArrayList;
import net.myvietnam.mvncore.exception.DatabaseException;
import net.myvietnam.mvncore.exception.AssertionException;

class MVNForumPermissionFactory {

    private MVNForumPermissionFactory() {
    }

    static MVNForumPermission getAnonymousPermission()
        throws DatabaseException, AssertionException {

        ArrayList permList = MVNForumPermissionWebHelper.getPermissionsForGroupGuest();
        int size = permList.size();

        MVNForumPermissionImpl permission = new MVNForumPermissionImpl();
        for (int i = 0; i < size; i++) {
            int perm = ((Integer)permList.get(i)).intValue();
            permission.setPermission(perm);
        }
        return permission;
    }

    static MVNForumPermission getAuthenticatedPermission(int memberID)
        throws DatabaseException, AssertionException {
        ArrayList permList = MVNForumPermissionWebHelper.getPermissionsForMember(memberID);
        int size = permList.size();

        MVNForumPermissionImpl permission = new MVNForumPermissionImpl();
        for (int i = 0; i < size; i++) {
            int perm = ((Integer)permList.get(i)).intValue();
            permission.setPermission(perm);
        }
        permission.setPermission(MVNForumPermission.PERMISSION_AUTHENTICATED);

        // The Admin (id = 1) always has SystemAdmin permission
        if (memberID == 1) {
            permission.setPermission(MVNForumPermission.PERMISSION_SYSTEM_ADMIN);
        }
        return permission;
    }
}
