/*
 * $Header: /cvsroot/mvnforum/mvnforum/src/net/myvietnam/mvnplugin/mvnforum/auth/MVNForumPermissionImpl.java,v 1.3 2002/12/14 19:01:18 minhnn Exp $
 * $Revision: 1.3 $
 * $Date: 2002/12/14 19:01:18 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding mvnForum
 * must remain intact in the scripts and in the outputted HTML
 * The "powered by" text/logo with a link back to
 * http://www.mvnForum.com and http://www.MyVietnam.net in the footer of the pages MUST
 * remain visible when the pages are viewed on the internet or intranet.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Support can be obtained from support forums at:
 * http://www.mvnForum.com/mvnforum/index
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvnplugin.mvnforum.auth;

import net.myvietnam.mvncore.exception.AssertionException;

/**
 * This class is private in the package
 */
class MVNForumPermissionImpl extends AbstractPermission implements MVNForumPermission {

    MVNForumPermissionImpl() {
    }

    /**
     * The ONLY way to set permission, so this MUST have default package access
     */
    void setPermission(int permission) throws AssertionException {
        switch (permission) {
            case PERMISSION_AUTHENTICATED:
                authenticated   = true;
                break;
/**************************************************************************
 * Combined permissions, range from 100 to 199
 * A permission in this range is the combination of other permissions
 **************************************************************************/
            case PERMISSION_SYSTEM_ADMIN:
                adminSystem     = true;
                newForum        = true;
                editForum       = true;
                deleteForum     = true;
                newCategory     = true;
                editCategory    = true;
                deleteCategory  = true;
                sendMail        = true;
                useAvatar       = true;
                useMessage      = true;

                readPost        = true;
                newThread       = true;
                newPost         = true;
                editPost        = true;
                deletePost      = true;
                newPoll         = true;
                editPoll        = true;
                deletePoll      = true;
                useAttachment   = true;
                getAttachment   = true;
                break;

            case PERMISSION_FORUM_ADMIN:
                newForum        = true;
                editForum       = true;
                deleteForum     = true;
                newCategory     = true;
                editCategory    = true;
                deleteCategory  = true;

                readPost        = true;
                newThread       = true;
                newPost         = true;
                editPost        = true;
                deletePost      = true;
                newPoll         = true;
                editPoll        = true;
                deletePoll      = true;
                useAttachment   = true;
                getAttachment   = true;
                break;

            case PERMISSION_FORUM_MODERATOR:
                editForum       = true;
                editCategory    = true;

                readPost        = true;
                newThread       = true;
                newPost         = true;
                editPost        = true;
                deletePost      = true;
                newPoll         = true;
                editPoll        = true;
                deletePoll      = true;
                useAttachment   = true;
                getAttachment   = true;
                break;

            case PERMISSION_LIMITED_USER:
                readPost        = true;
                /** @todo at the 1.0.0 beta2 release, new post is disable*/
//                newPost         = true;
                break;

            case PERMISSION_NORMAL_USER:
                useAvatar       = true;
                useMessage      = true;

                readPost        = true;
                newThread       = true;
                newPost         = true;
                getAttachment   = true;
                break;

    /**
     * Can:
     * - login, read thread and post, reply to a thread
     * - new thread, use avatar, use private message, get attachment
     * - use attachment, create poll
     */
            case PERMISSION_POWER_USER:
                useAvatar       = true;
                useMessage      = true;

                readPost        = true;
                newThread       = true;
                newPost         = true;
                newPoll         = true;
                useAttachment   = true;
                getAttachment   = true;
                break;

/**************************************************************************
 * Individual Permissions for global usages, range from 1000 to 2000
 **************************************************************************/


/**************************************************************************
 * Individual Permissions that can be applied for individual forum usages,
 * (of course it can be applied to all forums), range from 2000 to 3000
 **************************************************************************/


/**************************************************************************
 * cannot find, just throw an Exception
 **************************************************************************/

            default:
                throw new AssertionException("Currently dont support permission = " + permission);
        }//switch
    }
}
