/*
 * $Header: /cvsroot/mvnforum/mvnforum/src/net/myvietnam/mvnplugin/mvnforum/auth/OnlineUserImpl.java,v 1.3 2002/12/02 18:34:07 minhnn Exp $
 * $Revision: 1.3 $
 * $Date: 2002/12/02 18:34:07 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding mvnForum
 * must remain intact in the scripts and in the outputted HTML
 * The "powered by" text/logo with a link back to
 * http://www.mvnForum.com and http://www.MyVietnam.net in the footer of the pages MUST
 * remain visible when the pages are viewed on the internet or intranet.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Support can be obtained from support forums at:
 * http://www.mvnForum.com/mvnforum/index
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvnplugin.mvnforum.auth;

import net.myvietnam.mvncore.util.DateUtil;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

class OnlineUserImpl implements OnlineUser {

    private int memberID = 0;// must be 0 for anonymous user

    private String memberName = "";

    private MVNForumPermission permission = null;

    private OnlineUserAction onlineUserAction = new OnlineUserAction();

    private int hourOffset = 0;

    // todo configurable from properies file
    private DateFormat dateFormatter = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");

    /**
     * default access constructor, prevent outsite creation
     */
    OnlineUserImpl() {
    }

    public int getMemberID() {
        return memberID;
    }

    public String getMemberName() {
        return memberName;
    }

    public MVNForumPermission getPermission() {
        return permission;
    }

    public OnlineUserAction getOnlineUserAction() {
        return onlineUserAction;
    }

    public java.util.Date convertGMTDate(java.util.Date gmtDate) {
        return DateUtil.convertGMTDate(gmtDate, hourOffset);
    }

    public java.sql.Timestamp convertGMTTimestamp(java.sql.Timestamp gmtTimestamp) {
        return DateUtil.convertGMTTimestamp(gmtTimestamp, hourOffset);
    }

    /** @todo reimplement this method */
    public String getGMTDateFormat(java.util.Date gmtDate) {
        java.util.Date date = DateUtil.convertGMTDate(gmtDate, hourOffset);
        return dateFormatter.format(date);
//        return date.toString();
    }

    /** @todo reimplement this method */
    public String getGMTTimestampFormat(java.sql.Timestamp gmtTimestamp) {
        java.sql.Timestamp timestamp = DateUtil.convertGMTTimestamp(gmtTimestamp, hourOffset);
        return dateFormatter.format(timestamp);
//        return timestamp.toString();
    }

/*****************************************************************
 * Default methods, only for internal package usage
 *****************************************************************/
    void setMemberID(int memberID) {
        this.memberID = memberID;
        onlineUserAction.setMemberID(memberID);
    }

    void setMemberName(String memberName) {
        this.memberName = memberName;
        onlineUserAction.setMemberName(memberName);
    }

    /**
     * NOTE: this method SHOULD ONLY BE CALLED from OnlineUserFactory
     */
    void setPermission(MVNForumPermission permission) {
        this.permission = permission;
    }

    void setHourOffset(int hourOffset) {
        this.hourOffset = hourOffset;
    }
}
