/*
 * $Header: /cvsroot/mvnforum/mvnforum/src/net/myvietnam/mvnplugin/mvnforum/user/ForumURLMapHandler.java,v 1.4 2002/12/15 18:59:36 minhnn Exp $
 * $Revision: 1.4 $
 * $Date: 2002/12/15 18:59:36 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding mvnForum
 * must remain intact in the scripts and in the outputted HTML
 * The "powered by" text/logo with a link back to
 * http://www.mvnForum.com and http://www.MyVietnam.net in the footer of the pages MUST
 * remain visible when the pages are viewed on the internet or intranet.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Support can be obtained from support forums at:
 * http://www.mvnForum.com/mvnforum/index
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvnplugin.mvnforum.user;

import javax.servlet.http.HttpServletRequest;
import net.myvietnam.mvncore.exception.MissingURLMapEntryException;
import net.myvietnam.mvnplugin.mvnforum.URLMap;
import net.myvietnam.mvnplugin.mvnforum.MVNForumGlobal;

class ForumURLMapHandler {

    ForumURLMapHandler() {
    }

    /**
     * We must pass the requestURI to this method, instead of from request,
     * because requestURI may be changed from Processor before call this method
     * NOTE: Currently we dont use the param request
     */
    public URLMap getMap(String requestURI, HttpServletRequest request) throws MissingURLMapEntryException {
        URLMap map = new URLMap();

        if (requestURI.equals("/error")) {
            map.setResponse("/mvnplugin/mvnforum/user/error.jsp");
        } else if (requestURI.equals("") || requestURI.equals("/")) {
            map.setResponse(UserModuleConfig.URL_PATTERN + "/index");
        } else if (requestURI.equals("/index")) {
            map.setResponse("/mvnplugin/mvnforum/user/listforums.jsp");//index.jsp
        } else if (requestURI.equals("/listonlineusers")) {
            map.setResponse("/mvnplugin/mvnforum/user/listonlineusers.jsp");

        } else if (requestURI.equals("/listforums")) {
            map.setResponse("/mvnplugin/mvnforum/user/listforums.jsp");
        } else if (requestURI.equals("/listthreads")) {
            map.setResponse("/mvnplugin/mvnforum/user/listthreads.jsp");
        } else if (requestURI.equals("/listrecentthreads")) {
            map.setResponse("/mvnplugin/mvnforum/user/listrecentthreads.jsp");

        } else if (requestURI.equals("/addpost")) {
            map.setResponse("/mvnplugin/mvnforum/user" + MVNForumGlobal.LANGUAGE_DIR + "/addpost.jsp");
        } else if (requestURI.equals("/addpostprocess")) {
            map.setResponse("/mvnplugin/mvnforum/user/addpostsuccess.jsp");
        } else if (requestURI.equals("/editpost")) {
            map.setResponse("/mvnplugin/mvnforum/user/addpost.jsp");//editpost.jsp
        } else if (requestURI.equals("/updatepost")) {
            map.setResponse("/mvnplugin/mvnforum/user/updatepostsuccess.jsp");

        } else if (requestURI.equals("/viewthread")) {
            map.setResponse("/mvnplugin/mvnforum/user/viewthread.jsp");
        } else if (requestURI.equals("/deletethread")) {
            map.setResponse("/mvnplugin/mvnforum/user/deletethread.jsp");
        } else if (requestURI.equals("/deletethreadprocess")) {
            map.setResponse(UserModuleConfig.URL_PATTERN + "/index");
            //map.setResponse("/mvnplugin/mvnforum/user/deletethreadsuccess.jsp");
        } else if (requestURI.equals("/viewmember")) {
            map.setResponse("/mvnplugin/mvnforum/user/viewmember.jsp");
        } else if (requestURI.equals("/listmembers")) {
            map.setResponse("/mvnplugin/mvnforum/user/listmembers.jsp");
        } else if (requestURI.equals("/editmember")) {
            map.setResponse("/mvnplugin/mvnforum/user" + MVNForumGlobal.LANGUAGE_DIR + "/editmember.jsp");
        } else if (requestURI.equals("/updatemember")) {
            map.setResponse("/mvnplugin/mvnforum/user/updatemembersuccess.jsp");
        } else if (requestURI.equals("/login")) {
            map.setResponse("/mvnplugin/mvnforum/user/login.jsp");
        } else if (requestURI.equals("/loginprocess")) {
            //map.setResponse("/mvnplugin/mvnforum/user/loginsuccess.jsp");
            map.setResponse(UserModuleConfig.URL_PATTERN + "/index");
        } else if (requestURI.equals("/logout")) {
            map.setResponse("/mvnplugin/mvnforum/user/login.jsp");
        } else if (requestURI.equals("/help")) {
            map.setResponse("/mvnplugin/mvnforum/user/help.jsp");
        } else if (requestURI.equals("/search")) {
            map.setResponse("/mvnplugin/mvnforum/user/search.jsp");
        } else if (requestURI.equals("/registermember")) {
            map.setResponse("/mvnplugin/mvnforum/user" + MVNForumGlobal.LANGUAGE_DIR + "/addmember.jsp");
        } else if (requestURI.equals("/registermemberprocess")) {
            map.setResponse("/mvnplugin/mvnforum/user/addmembersuccess.jsp");
        } else if (requestURI.equals("/myprofile")) {
            map.setResponse("/mvnplugin/mvnforum/user/myprofile.jsp");
        } else if (requestURI.equals("/changepassword")) {
            map.setResponse("/mvnplugin/mvnforum/user/changepassword.jsp");
        } else if (requestURI.equals("/changepasswordprocess")) {
            map.setResponse("/mvnplugin/mvnforum/user/changepasswordsuccess.jsp");
        } else if (requestURI.equals("/changeemail")) {
            map.setResponse("/mvnplugin/mvnforum/user/changeemail.jsp");
        } else if (requestURI.equals("/changeemailprocess")) {
            map.setResponse("/mvnplugin/mvnforum/user/changeemailsuccess.jsp");
        } else if (requestURI.equals("/changesignature")) {
            map.setResponse("/mvnplugin/mvnforum/user/changesignature.jsp");
        } else if (requestURI.equals("/changesignatureprocess")) {
            map.setResponse("/mvnplugin/mvnforum/user/changesignaturesuccess.jsp");
        } else if (requestURI.equals("/forgotpassword")) {
            map.setResponse("/mvnplugin/mvnforum/user/forgotpassword.jsp");
        } else if (requestURI.equals("/forgotpasswordprocess")) {
            map.setResponse("/mvnplugin/mvnforum/user/forgotpasswordsuccess.jsp");
        } else if (requestURI.equals("/resetpassword")) {
            map.setResponse("/mvnplugin/mvnforum/user/resetpassword.jsp");
        } else if (requestURI.equals("/resetpasswordprocess")) {
            map.setResponse("/mvnplugin/mvnforum/user/resetpasswordsuccess.jsp");
        } else if (requestURI.equals("/changeavatar")) {
            map.setResponse("/mvnplugin/mvnforum/user/changeavatar.jsp");
        } else if (requestURI.equals("/uploadavatar")) {
            map.setResponse(UserModuleConfig.URL_PATTERN + "/myprofile");
        } else if (requestURI.equals("/updateavatar")) {
            map.setResponse(UserModuleConfig.URL_PATTERN + "/myprofile");
        }

        // unknown module, we throw an exception
        if (map.getResponse() == null) {
            String errorMessage = "Cannot find matching entry in URLMap for '" + requestURI + "'. Please contact the administrator.";
            throw new MissingURLMapEntryException(errorMessage);
        }
        return map;
    }
}
