/*
 * $Header: /cvsroot/mvnforum/mvnforum/src/net/myvietnam/mvnplugin/mvnforum/user/ForumUserServlet.java,v 1.2 2002/11/27 17:16:27 minhnn Exp $
 * $Revision: 1.2 $
 * $Date: 2002/11/27 17:16:27 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding mvnForum
 * must remain intact in the scripts and in the outputted HTML
 * The "powered by" text/logo with a link back to
 * http://www.mvnForum.com and http://www.MyVietnam.net in the footer of the pages MUST
 * remain visible when the pages are viewed on the internet or intranet.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Support can be obtained from support forums at:
 * http://www.mvnForum.com/mvnforum/index
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvnplugin.mvnforum.user;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.IOException;
import net.myvietnam.mvncore.db.DBConnectionManager;
import net.myvietnam.mvnplugin.mvnforum.MVNForumConfig;

public class ForumUserServlet extends HttpServlet {

    private UserModuleProcessor userModuleProcessor  = null;
    //private HitCountWebHandler   hitcountWebHandler     = null;
    //private SessionLogWebHandler sessionLogWebHandler   = null;
    private static int count = 0;

    /**Initialize global variables*/
    public void init() throws ServletException {
        /*
        if (MVNForumConfig.isShouldRun() == false) {
            throw new ServletException("Cannot init system. Reason = " + MVNForumConfig.getReason());
        }
        */
        userModuleProcessor  = new UserModuleProcessor(this);
        //hitcountWebHandler   = new HitCountWebHandler();
        //sessionLogWebHandler  = new SessionLogWebHandler();
        System.out.println("<<----The ForumUserServlet has been inited!---->>");
    }

    /**Process the HTTP Get request*/
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        process(request, response);
    }

    /**Process the HTTP Post request*/
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        process(request, response);
    }

    public void process(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException {
        long startTime = System.currentTimeMillis();
        count++;
        try {
            String requestURI = request.getPathInfo();
            String responseURI = null;

            // step 0: update the HitCount and SessionLog per session for forum module
            /*
            try {
                // we customize the requestURI here to be /model/
                //hitcountWebHandler.increaseHit(request, "/model/");
                //sessionLogWebHandler.logUser(request);
            } catch (Exception e) {
                responseURI = "/home/error.jsp";
                request.getSession().setAttribute("ErrorMessage", StringUtil.getEmptyStringIfNull(e.getMessage()));
                getServletContext().getRequestDispatcher(responseURI).forward(request, response);
                return;
            }
            */
            // this method should not throw Exception (it must catch all Exceptions)
            userModuleProcessor.process(request, response);
        } catch (Exception e) {
            // so it should never go here
            e.printStackTrace();
        } finally {
            long processTime = System.currentTimeMillis() - startTime;
            System.out.println("ForumUserServlet processed " + count + " times. Took " + processTime + " miliseconds.\n");
        }
    }// process

    /**
     * Clean up resources
     */
    public void destroy() {
        System.out.println("<<----The ForumUserServlet has been destroyed!---->>");
        // This code will release all connections currently pooled.
        // The next call to #getConnection will recreate the pool.
        DBConnectionManager.getInstance().release();
    }
}
