/*
 * $Header: /cvsroot/mvnforum/mvnforum/src/net/myvietnam/mvnplugin/mvnforum/user/MemberWebHandler.java,v 1.4 2002/12/14 19:01:25 minhnn Exp $
 * $Revision: 1.4 $
 * $Date: 2002/12/14 19:01:25 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding mvnForum
 * must remain intact in the scripts and in the outputted HTML
 * The "powered by" text/logo with a link back to
 * http://www.mvnForum.com and http://www.MyVietnam.net in the footer of the pages MUST
 * remain visible when the pages are viewed on the internet or intranet.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Support can be obtained from support forums at:
 * http://www.mvnForum.com/mvnforum/index
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvnplugin.mvnforum.user;

import javax.servlet.http.*;
import java.sql.*;
import java.util.Collection;
import java.util.List;// for upload stuff
import net.myvietnam.mvncore.exception.*;
import net.myvietnam.mvncore.util.ParamUtil;
import net.myvietnam.mvncore.util.DateUtil;
import net.myvietnam.mvncore.util.StringUtil;
import net.myvietnam.mvncore.util.ImageUtil;
import net.myvietnam.mvncore.util.FileUtil;
import net.myvietnam.mvncore.util.MailUtil;
import net.myvietnam.mvncore.filter.DisableHtmlTagFilter;
import net.myvietnam.mvncore.security.Encoder;
import net.myvietnam.mvncore.fileupload.*;
import net.myvietnam.mvnplugin.mvnforum.MVNForumConstant;
import net.myvietnam.mvnplugin.mvnforum.MVNForumInfo;
import net.myvietnam.mvnplugin.mvnforum.MVNForumGlobal;
import net.myvietnam.mvnplugin.mvnforum.MVNForumConfig;
import net.myvietnam.mvnplugin.mvnforum.MyUtil;
import net.myvietnam.mvnplugin.mvnforum.db.MemberBean;
import net.myvietnam.mvnplugin.mvnforum.auth.*;

class MemberWebHandler {

    private OnlineUserManager userManager = OnlineUserManager.getInstance();

    MemberWebHandler() {
    }

    void processAdd(HttpServletRequest request)
        throws BadInputException, CreateException, DatabaseException, DuplicateKeyException, ForeignKeyNotFoundException {

        Timestamp now = DateUtil.getCurrentGMTTimestamp();

        String memberName           = ParamUtil.getParameterSafe(request, "MemberName", true);// check good name
        /** @todo move to a name filter */
        if ( memberName.equalsIgnoreCase(MVNForumConstant.MEMBER_GUEST_NAME) ||
             memberName.equalsIgnoreCase("Moderator") ) {
            throw new BadInputException("Cannot register member with a reserved name : " + memberName);
        }
        StringUtil.checkGoodName(memberName);

        String memberPassword1      = ParamUtil.getParameterPassword(request, "MemberMatkhau", 3, 0);
        String memberPassword2      = ParamUtil.getParameterPassword(request, "MemberMatkhauConfirm", 3, 0);
        if (!memberPassword1.equals(memberPassword2)) {
            throw new BadInputException("Password and confirmed password are not the same, please try again.");
        }
        String memberPassword       = Encoder.getMD5_Base64(memberPassword1);

        String memberEmail          = ParamUtil.getParameterEmail(request, "MemberEmail");
        String memberEmailConfirm   = ParamUtil.getParameterEmail(request, "MemberEmailConfirm");
        if (!memberEmail.equals(memberEmailConfirm)) {
            throw new BadInputException("Email and confirmed email are not the same, please try again.");
        }
        String memberFirstEmail     = memberEmail;

        int memberEmailVisible      = ParamUtil.getParameterBoolean(request, "MemberEmailVisible")? 1 : 0;
        int memberNameVisible       = ParamUtil.getParameterBoolean(request, "MemberNameVisible") ? 1 : 0;
        String memberFirstIP        = request.getRemoteAddr();
        String memberLastIP         = memberFirstIP;
        Timestamp memberCreationDate= now;
        Timestamp memberModifiedDate= now;
        Timestamp memberLastLogon   = now;// xem lai
        int memberOption            = 0;//xem lai
        int memberStatus            = 0;// xem lai, ex: co can active khong?
        String memberActivateCode   = "";// xem lai
        int memberMessageOption     = 0;// xem lai
        int memberPostsPerPage      = 10;//xem lai
        String memberTitle          = "";
        int memberTimeZone          = ParamUtil.getParameterTimeZone(request, "MemberTimeZone");
        String memberSkin           = "";
        String memberLanguage       = "";
        String memberFirstname      = ParamUtil.getParameterSafe(request, "MemberFirstname", true);
        String memberLastname       = ParamUtil.getParameterSafe(request, "MemberLastname", true);
        int memberGender            = ParamUtil.getParameterBoolean(request, "MemberGender") ? 1 : 0;

        //Date memberBirthday         = ParamUtil.getParameterDate(request, "MemberBirthday");
        Date memberBirthday         = ParamUtil.getParameterDate(request, "day", "month", "year");
        /** @todo : rewrite this code */
        /*
        long nowtime = System.currentTimeMillis();
        long oldest = nowtime - 100*DateUtil.YEAR;
        long youngest = nowtime - 10*DateUtil.YEAR;
        long age = (nowtime - memberBirthday.getTime())/DateUtil.YEAR;
        if (memberBirthday.getTime() > youngest || memberBirthday.getTime() < oldest) {
            System.out.println("age = " + age + " date = " + memberBirthday + " gettime = " + memberBirthday.getTime());
            throw new BadInputException("Your age is not allow: " + age);
        }*/

        String memberAddress        = ParamUtil.getParameterSafe(request, "MemberAddress", false);
        String memberCity           = ParamUtil.getParameterSafe(request, "MemberCity", false);
        String memberState          = ParamUtil.getParameterSafe(request, "MemberState", false);
        String memberCountry        = ParamUtil.getParameterSafe(request, "MemberCountry", false);
        String memberPhone          = ParamUtil.getParameterSafe(request, "MemberPhone", false);
        String memberMobile         = ParamUtil.getParameterSafe(request, "MemberMobile", false);
        String memberFax            = ParamUtil.getParameterSafe(request, "MemberFax", false);
        String memberCareer         = ParamUtil.getParameterSafe(request, "MemberCareer", false);
        String memberHomepage       = ParamUtil.getParameterSafe(request, "MemberHomepage", false);
        String memberYahoo          = ParamUtil.getParameterSafe(request, "MemberYahoo", false);
        String memberAol            = ParamUtil.getParameterSafe(request, "MemberAol", false);
        String memberIcq            = ParamUtil.getParameterSafe(request, "MemberIcq", false);
        String memberMsn            = ParamUtil.getParameterSafe(request, "MemberMsn", false);
        String memberCoolLink1      = ParamUtil.getParameterSafe(request, "MemberCoolLink1", false);
        String memberCoolLink2      = ParamUtil.getParameterSafe(request, "MemberCoolLink2", false);

        MemberWebHelper.createMember(memberName, memberPassword, memberFirstEmail,
                                   memberEmail, memberEmailVisible, memberNameVisible,
                                   memberFirstIP, memberLastIP, 0/*memberViewCount*/,
                                   0/*memberPostCount*/, memberCreationDate, memberModifiedDate,
                                   memberLastLogon, memberOption, memberStatus,
                                   memberActivateCode, ""/*memberTempPassword*/, 0/*memberMessageCount*/,
                                   memberMessageOption, memberPostsPerPage, 0/*memberWarnCount*/,
                                   0/*memberVoteCount*/, 0/*memberVoteTotalStars*/, 0/*memberRewardPoints*/,
                                   memberTitle, memberTimeZone, ""/*memberSignature*/,
                                   ""/*memberAvatar*/, memberSkin, memberLanguage,
                                   memberFirstname, memberLastname, memberGender,
                                   memberBirthday, memberAddress, memberCity,
                                   memberState, memberCountry, memberPhone,
                                   memberMobile, memberFax, memberCareer,
                                   memberHomepage, memberYahoo, memberAol,
                                   memberIcq, memberMsn, memberCoolLink1,
                                   memberCoolLink2);

        // Now, create 2 default folders for each member
        int memberID = MemberWebHelper.getMemberIDFromMemberName(memberName);
        MessageFolderWebHelper.createMessageFolder(MVNForumConstant.MESSAGE_FOLDER_INBOX, memberID, 0, now, now);
        MessageFolderWebHelper.createMessageFolder(MVNForumConstant.MESSAGE_FOLDER_SENT, memberID, 0, now, now);

        /**@todo: check it*/
        //request.setAttribute("MemberID", memberID);
        /*
        // Now see if the member want to join the maillist
        boolean joinMailList = ParamUtil.getParameterBoolean(request, "JoinMailList");
        if (joinMailList) {
            String name = memberFirstname + " " + memberLastname;
            String mailInfo = "You should receive a confirmed email in a few minutes.";
            try {
                try {
                    maillistWebHelper.findByAlternateKey(memberEmail);
                    // NOTE: we should check if the email in maillist is enable
                    return; // the email is already in the maillist
                } catch (ObjectNotFoundException ex) {
                    // ok, go ahead
                }

                // I hope that the create method is ok, so the Exception below is for sendMail
                maillistWebHelper.create(name, memberEmail, true);
                // try to send an email
                MailContent.sendMail_forMailList(name, memberEmail);
            } catch (Exception ex) {
                mailInfo = "Note: you have been added to our mailling list successfully, but we have problem with our mail server so we cannot send you a confirmed mail. Please report this to Website administrator.";
                // do nothing, because we just try to send an email
            }
            request.setAttribute("MailInfo", mailInfo);
        }//if
        */
    }

    public void processUpdate(HttpServletRequest request)
        throws BadInputException, DatabaseException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();

        Timestamp now = DateUtil.getCurrentGMTTimestamp();

        // column(s) to update
        int memberEmailVisible      = ParamUtil.getParameterBoolean(request, "MemberEmailVisible")? 1 : 0;
        int memberNameVisible       = ParamUtil.getParameterBoolean(request, "MemberNameVisible") ? 1 : 0;
        int memberOption            = ParamUtil.getParameterInt(request, "MemberOption");
        int memberStatus            = 0;//xem lai
        int memberMessageOption     = ParamUtil.getParameterInt(request, "MemberMessageOption");
        int memberPostsPerPage      = ParamUtil.getParameterInt(request, "MemberPostsPerPage");
        int memberTimeZone          = ParamUtil.getParameterTimeZone(request, "MemberTimeZone");
        String memberSkin           = ParamUtil.getParameterSafe(request, "MemberSkin", false);
        String memberLanguage       = ParamUtil.getParameterSafe(request, "MemberLanguage", false);
        String memberFirstname      = ParamUtil.getParameterSafe(request, "MemberFirstname", true);
        String memberLastname       = ParamUtil.getParameterSafe(request, "MemberLastname", true);
        int memberGender            = ParamUtil.getParameterBoolean(request, "MemberGender")? 1 : 0;
        Date memberBirthday         = ParamUtil.getParameterDate(request, "MemberBirthday");
        String memberAddress        = ParamUtil.getParameterSafe(request, "MemberAddress", false);
        String memberCity           = ParamUtil.getParameterSafe(request, "MemberCity", false);
        String memberState          = ParamUtil.getParameterSafe(request, "MemberState", false);
        String memberCountry        = ParamUtil.getParameterSafe(request, "MemberCountry", false);
        String memberPhone          = ParamUtil.getParameterSafe(request, "MemberPhone", false);
        String memberMobile         = ParamUtil.getParameterSafe(request, "MemberMobile", false);
        String memberFax            = ParamUtil.getParameterSafe(request, "MemberFax", false);
        String memberCareer         = ParamUtil.getParameterSafe(request, "MemberCareer", false);
        String memberHomepage       = ParamUtil.getParameterSafe(request, "MemberHomepage", false);
        String memberYahoo          = ParamUtil.getParameterSafe(request, "MemberYahoo", false);
        String memberAol            = ParamUtil.getParameterSafe(request, "MemberAol", false);
        String memberIcq            = ParamUtil.getParameterSafe(request, "MemberIcq", false);
        String memberMsn            = ParamUtil.getParameterSafe(request, "MemberMsn", false);
        String memberCoolLink1      = ParamUtil.getParameterSafe(request, "MemberCoolLink1", false);
        String memberCoolLink2      = ParamUtil.getParameterSafe(request, "MemberCoolLink2", false);

        MemberWebHelper.updateMember(memberID, // primary key
                               memberEmailVisible, memberNameVisible, now/*memberModifiedDate*/,
                               memberOption, memberStatus, memberMessageOption,
                               memberPostsPerPage, memberTimeZone, memberSkin,
                               memberLanguage, memberFirstname, memberLastname,
                               memberGender, memberBirthday, memberAddress,
                               memberCity, memberState, memberCountry,
                               memberPhone, memberMobile, memberFax,
                               memberCareer, memberHomepage, memberYahoo,
                               memberAol, memberIcq, memberMsn,
                               memberCoolLink1, memberCoolLink2);
    }

    /** @todo: use new method of WebHelper */
    public void prepareEditEmail(HttpServletRequest request)
        throws DatabaseException, BadInputException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();
        MemberBean memberBean   = MemberWebHelper.getMember_forViewCurrentMember(memberID);
        request.setAttribute("MemberEmail", memberBean.getMemberEmail());
    }

    public void processUpdateEmail(HttpServletRequest request)
        throws BadInputException, DatabaseException, DuplicateKeyException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();

        // column(s) to update
        String memberEmail          = ParamUtil.getParameterEmail(request, "MemberEmail");
        String memberEmailConfirm   = ParamUtil.getParameterEmail(request, "MemberEmailConfirm");
        if (!memberEmail.equals(memberEmailConfirm)) throw new BadInputException("Email and confirmed email are not the same, please try again.");

        /**@todo: validate email checking by sending email*/
        MemberWebHelper.updateMemberEmail(memberID, // primary key
                               memberEmail);
    }

    public void processUpdatePassword(HttpServletRequest request)
        throws BadInputException, DatabaseException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();

        // NOTE: that we dont use getParameterPassword here since it will not forward-compatible
        String memberOldPassword    = ParamUtil.getParameter(request, "MemberOldMatkhau", true);
        String oldEncodedPassword   = Encoder.getMD5_Base64(memberOldPassword);
        String currentPassword      = MemberWebHelper.getMemberPassword(memberID);
        if (!currentPassword.equals(oldEncodedPassword)) {
            throw new BadInputException("You have typed the wrong current password, please try again.");
        }

        // column(s) to update
        String memberPassword1      = ParamUtil.getParameterPassword(request, "MemberMatkhau", 3, 0);
        String memberPassword2      = ParamUtil.getParameterPassword(request, "MemberMatkhauConfirm", 3, 0);
        if (!memberPassword1.equals(memberPassword2)) {
            throw new BadInputException("Password and confirmed password are not the same, please try again.");
        }
        String memberPassword       = Encoder.getMD5_Base64(memberPassword1);

        MemberWebHelper.updateMemberPassword(memberID, // primary key
                               memberPassword);
    }

    public void prepareView_forCurrentMember(HttpServletRequest request)
        throws DatabaseException, BadInputException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();
        MemberBean memberBean = MemberWebHelper.getMember_forViewCurrentMember(memberID);
        request.setAttribute("MemberBean", memberBean);
    }

    public void prepareEdit_forCurrentMember(HttpServletRequest request)
        throws DatabaseException, BadInputException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();
        MemberBean memberBean = MemberWebHelper.getMember_forEditCurrentMember(memberID);
        request.setAttribute("MemberBean", memberBean);
    }

    /** @todo: use new method of WebHelper */
    public void prepareEditSignature(HttpServletRequest request)
        throws DatabaseException, BadInputException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();
        MemberBean memberBean   = MemberWebHelper.getMember_forViewCurrentMember(memberID);
        request.setAttribute("MemberSignature", memberBean.getMemberSignature());
    }

    public void processUpdateSignature(HttpServletRequest request)
        throws BadInputException, DatabaseException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();

        // column(s) to update
        String memberSignature      = ParamUtil.getParameter(request, "MemberSignature");
        memberSignature = DisableHtmlTagFilter.filter(memberSignature);

        MemberWebHelper.updateMemberSignature(memberID, // primary key
                               memberSignature);
    }

    /** @todo: use new method of WebHelper */
    public void prepareEditAvatar(HttpServletRequest request)
        throws DatabaseException, BadInputException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID = onlineUser.getMemberID();
        MemberBean memberBean = MemberWebHelper.getMember_forViewCurrentMember(memberID);
        request.setAttribute("MemberBean", memberBean);
    }

    /**
     * Change picture from our predefined picture
     * NOTE: this method will delete uploaded image (if any) of the member
     */
    public void updateMemberAvatar(javax.servlet.ServletContext context, HttpServletRequest request)
        throws BadInputException, DatabaseException, AuthenticationException, AssertionException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID        = onlineUser.getMemberID();
        String memberName   = onlineUser.getMemberName();

        // first, we delete uploaded image if there is one
        StringBuffer bufferPicFile = new StringBuffer(128);
        bufferPicFile.append(context.getRealPath(MVNForumGlobal.UPLOADED_AVATAR_DIR));
        bufferPicFile.append(java.io.File.separatorChar).append(memberName).append(".jpg");
        String picFile =  bufferPicFile.toString();

        System.out.println("Delete avatar: " + picFile);
        System.out.println("String length = " + picFile.length());
        java.io.File file = new java.io.File(picFile);
        file.delete();// we dont need to check the returned value

        // then we update the database with new one
        String memberPicture = ParamUtil.getParameter(request, "MemberAvatar");
        MemberWebHelper.updateMemberAvatar(memberID, memberPicture);
    }

    /**
     * upload user own avatar
     */
    public void uploadPicture(javax.servlet.ServletConfig config, HttpServletRequest request, HttpServletResponse response)
        throws AuthenticationException, java.io.IOException, AssertionException, BadInputException, DatabaseException {

        OnlineUser onlineUser = userManager.getOnlineUser(request);
        MVNForumPermission permission = onlineUser.getPermission();
        permission.ensureIsAuthenticated();

        int memberID        = onlineUser.getMemberID();
        String memberName   = onlineUser.getMemberName();

        FileUpload fileUpload = new FileUpload();
        fileUpload.setSizeMax(60000);//60K
        fileUpload.setSizeThreshold(100000);// max memory uesd = 100K (more than needed)
        //fileUpload.setAllowedFilesList("jpg");
        List fileItems;
        try {
            fileItems = fileUpload.parseRequest(request);
        } catch (FileUploadException ex) {
            ex.printStackTrace();
            throw new java.io.IOException("Cannot upload. Detail reason: " + ex.getMessage());
        }

        // make sure only one file upload
        if (fileItems.size() != 1) {
            throw new AssertionException("Assertion: Cannot upload more than 1 file when process upload picture for Member.");
        }

        //get the first and only file
        FileItem myFile = (FileItem)fileItems.get(0);
        if (myFile.isFormField() == true) {
            throw new AssertionException("Cannot process uploaded avatar with a form field.");
        }
        /*
        if (myFile.isMissing()) {
            throw new BadInputException("No file has been selected for upload. Please try again.");
        }*/

        // now everything all right, go ahead and create thumbnail
        java.io.InputStream inputStream = myFile.getInputStream();

        StringBuffer bufferPicFile = new StringBuffer(128);
        bufferPicFile.append(config.getServletContext().getRealPath(MVNForumGlobal.UPLOADED_AVATAR_DIR));
        bufferPicFile.append(java.io.File.separatorChar).append(memberName).append(".jpg");
        String thumbnailFile =  bufferPicFile.toString();

        System.out.println("uploaded file = " + thumbnailFile);
        //System.out.println("String length = " + thumbnailFile.length());
        ImageUtil.createThumbnail(inputStream, thumbnailFile, 150/*maxWidth*/, 150/*maxHeight*/);

        // now the image has been save, go ahead and update database
        StringBuffer bufferVirtualFile = new StringBuffer(128);
        bufferVirtualFile.append(request.getContextPath());
        bufferVirtualFile.append(MVNForumGlobal.UPLOADED_AVATAR_DIR);
        bufferVirtualFile.append("/").append(memberName).append(".jpg");
        String virtualFile =  bufferVirtualFile.toString();

        try {
            MemberWebHelper.updateMemberAvatar(memberID, virtualFile);
        } catch (DatabaseException ex) {// we dont need to catch BadInputException since the memberID is already exits
            System.out.println("Assertion in MemberWebHandler.uploadPicture");// we dont want it to be here
            // nead delete the file if the above database task fail
            FileUtil.deleteFile(thumbnailFile);
            throw ex;
        }
    }

    public void forgotPassword(HttpServletRequest request)
        throws BadInputException, DatabaseException, javax.mail.MessagingException, AssertionException {

        int memberID = 0;
        String memberName       = ParamUtil.getParameter(request, "MemberName");
        String memberEmail      = ParamUtil.getParameter(request, "MemberEmail");
        if (memberEmail.length() > 0) {
            memberEmail = ParamUtil.getParameterEmail(request, "MemberEmail");
        }

        if (memberName.length() > 0) {// user enter his MemberName
            // we find the email of this memberID, not the provided email
            memberID = MemberWebHelper.getMemberIDFromMemberName(memberName);
            MemberBean bean = MemberWebHelper.getMember_forPublic(memberID);
            memberEmail     = bean.getMemberEmail();
        } else if (memberEmail.length() > 0) {// user enter his email
            // we find the MemberID of this mail, now we sure that user didnt enter his MemberID
            memberID = MemberWebHelper.getMemberIDFromMemberEmail(memberEmail);
        } else {// user didnt enter any thing
            throw new BadInputException("You must enter at least your MemberName or email");
        }

        // now we have the correct pair of MemberID and MemberEmail

        // Check the  assumption above
        MemberBean bean = MemberWebHelper.getMember_forPublic(memberID);
        if (!memberEmail.equals(bean.getMemberEmail())) {
            throw new AssertionException("Assertion when process forgot password. This is a serious bug. Please contact the Web site administrator to report the bug.");
        }
        // end check

        //generate a temp password
        String tempPassword = Encoder.getMD5_Base64(String.valueOf(System.currentTimeMillis()));
        String urlEncodedTempPassword = java.net.URLEncoder.encode(tempPassword);

        MemberWebHelper.updateMemberTempPassword(memberID, tempPassword);

        // we have pass the assertion check, go ahead
        String serverName = ParamUtil.getServer2(request);

        StringBuffer passwordResetUrl = new StringBuffer(256);
            passwordResetUrl.append(serverName);
            passwordResetUrl.append(ParamUtil.getContextPath());
            passwordResetUrl.append(UserModuleConfig.getUrlPattern());
            passwordResetUrl.append("/resetpassword?temppassword=");
            passwordResetUrl.append(urlEncodedTempPassword);
            passwordResetUrl.append("&member=");
            passwordResetUrl.append(memberName);

        /** @todo use StringBuffer */
        String subject= "Your MEMBER password of website " + serverName;
        String body =   "This email is sent to you because you (or someone) have requested PASSWORD RESET from web site " + serverName + ".\n" +
                        "If you did not request this password reset feature, just ignore and DELETE this email.\n" +
                        "If you do want to reset your password, please use this url to reset your password:\n" +
                        passwordResetUrl.toString() + "\n" +
                        "Thank you for using " + MVNForumInfo.PRODUCT_DESC + " and we hope that you enjoy our forum.\n" +
                        serverName + " webmaster\n\n" +
                        "Your Member Name = " + memberName + "\n" +
                        "Your temporary password = " + tempPassword + "\n";

        System.out.println("subject = " + subject);
        System.out.println("body = " + body);
        MailUtil.sendMail(MVNForumConfig.getWebMasterEmail()/*use the default MailFrom value*/,
                          memberEmail/*to*/, ""/*cc*/, ""/*bcc*/, subject, body);
    }

    void resetPassword(HttpServletRequest request)
        throws BadInputException, DatabaseException {

        String memberName           = ParamUtil.getParameter(request, "member", true);
        // IMPORTANT: MUST check that temp password is not empty, because temppassword = empty
        // means cannot reset password
        String memberTempPassword   = ParamUtil.getParameter(request, "temppassword", true);

        int memberID = MemberWebHelper.getMemberIDFromMemberName(memberName);

        String currentTempPassword = MemberWebHelper.getMemberTempPassword(memberID);
        if (memberTempPassword.equals(currentTempPassword) == false) {
            throw new BadInputException("Your temporary password is not correct, please try the forgot password feature.");
        }

        String memberPassword1      = ParamUtil.getParameterPassword(request, "MemberMatkhau", 3, 0);
        String memberPassword2      = ParamUtil.getParameterPassword(request, "MemberMatkhauConfirm", 3, 0);
        if (!memberPassword1.equals(memberPassword2)) {
            throw new BadInputException("Password and confirmed password are not the same, please try again.");
        }
        String memberPassword       = Encoder.getMD5_Base64(memberPassword1);

        MemberWebHelper.updateMemberPassword(memberID, memberPassword);
        MemberWebHelper.updateMemberTempPassword(memberID, "");// reset the temp password
    }

/*************************************************
 * For public view
 *************************************************/
    public static void prepareView_forPublic(HttpServletRequest request)
        throws BadInputException, DatabaseException, AssertionException {

        String memberName = ParamUtil.getParameter(request, "member", false);
        // primary key column(s)
        int memberID;
        if (memberName.length() == 0) {
            memberID = ParamUtil.getParameterInt(request, "memberid");
        } else {// has MemberName
            /**@todo: improve this for better performance(dont use this method,
             * and write 2 new methods)*/
            StringUtil.checkGoodName(memberName);// check for better security
            memberID = MemberWebHelper.getMemberIDFromMemberName(memberName);
        }

        MemberWebHelper.increaseViewCount(memberID);
        MemberBean bean = MemberWebHelper.getMember_forPublic(memberID);

        request.setAttribute("MemberBean", bean);
    }

    /**
     * This method supports sorting base on many criteria
     */
    public void prepareListMembers_forPublic(HttpServletRequest request)
        throws DatabaseException, AssertionException, BadInputException {

        // for sort and order stuff
        String sort  = ParamUtil.getParameter(request, "sort");
        String order = ParamUtil.getParameter(request, "order");
        if (sort.length() == 0) sort = "MemberCreationDate";
        if (order.length()== 0) order = "DESC";

        // we continue
        int offset = 0;
        try {
            offset = ParamUtil.getParameterInt(request, "offset");
        } catch (BadInputException e) {
            // do nothing
        }

        int totalMembers = MemberWebHelper.getNumberOfMembers();
        if (offset > totalMembers) {
            throw new BadInputException("The offset is not allowed to be greater than total members.");
        }

        Collection memberRows = MemberWebHelper.getMembers_withSortSupport_limit(offset, MVNForumConfig.ROWS_IN_MEMBERS, sort, order);
        MyUtil.prepareNavigate(request, offset, memberRows.size(), totalMembers, MVNForumConfig.ROWS_IN_MEMBERS);

        request.setAttribute("MemberBeans", memberRows);
        request.setAttribute("TotalMembers", new Integer(totalMembers));
        request.setAttribute("offset", new Integer(offset));
    }

/****************************************************************************
 * Login/Logout stuffs
 ****************************************************************************/
/*
    public void processLogin(HttpServletRequest request)
        throws AuthenticationException, AssertionException, DatabaseException, BadInputException {

        String memberName     = ParamUtil.getParameter(request, "MemberName", true);
        String memberPassword = ParamUtil.getParameter(request, "MemberMatkhau", true);
        String encodedPassword = Encoder.getMD5_Base64(memberPassword);

        try {
            userManager.login(request, memberName, encodedPassword);
        } catch (AuthenticationException ex) {
            if (ex.getReason() == NotLoginException.WRONG_PASSWORD) {
                request.setAttribute("MemberName", memberName);// so user dont have to retype USER NAME
            }
            throw ex;
        }
    }

    public void processLogout(HttpServletRequest request)
        throws DatabaseException, AssertionException {
        userManager.logout(request);
    }
*/
}
