/*
 * $Header: /cvsroot/mvnforum/myvietnam/src/net/myvietnam/mvncore/db/DBOptions.java,v 1.3 2002/12/04 12:17:27 minhnn Exp $
 * $Revision: 1.3 $
 * $Date: 2002/12/04 12:17:27 $
 *
 * ====================================================================
 *
 * Copyright (C) 2002 by MyVietnam.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * All copyright notices regarding MyVietnam and MyVietnam CoreLib
 * MUST remain intact in the scripts and source code.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Correspondence and Marketing Questions can be sent to:
 * info@MyVietnam.net
 *
 * @author: Minh Nguyen  minhnn@MyVietnam.net
 * @author: Mai  Nguyen  mai.nh@MyVietnam.net
 */
package net.myvietnam.mvncore.db;

import java.util.ResourceBundle;
import java.util.MissingResourceException;

class DBOptions {
    private static final String OPTION_FILE_NAME = "mvncore_db_DBOptions";

    //default values
    boolean useDatasource   = false;

    // if useDatasource = true
    String datasourceName   = "";

    // if useDatasource = false
    String driverClassName  = "org.gjt.mm.mysql.Driver";
    String databaseURL      = "jdbc:mysql://localhost/test";
    String databaseUser     = "user";
    String databasePassword = "password";
    int maxConnection       = 20;
    int maxTimeToWait       = 2000;// 2 seconds

    DBOptions() {
        try {
            ResourceBundle res = ResourceBundle.getBundle(OPTION_FILE_NAME);

            String strUseDatasource = "false";
            try {
                strUseDatasource = res.getString("USE_DATASOURCE").trim();
            } catch (MissingResourceException ex) {
                // ignore exception
            }
            //System.out.println("strUseDatasource = '" + strUseDatasource + "'");
            if (strUseDatasource.equals("true")) {
                useDatasource       = true;
                datasourceName      = res.getString("DATASOURCE_NAME").trim();
            } else {
                useDatasource       = false;
                driverClassName     = res.getString("DRIVER_CLASS_NAME").trim();
                databaseURL         = res.getString("DATABASE_URL").trim();
                databaseUser        = res.getString("DATABASE_USER").trim();
                databasePassword    = res.getString("DATABASE_PASSWORD").trim();
                try {
                    maxConnection   = Integer.parseInt(res.getString("DATABASE_MAXCONNECTION").trim());
                } catch (Exception ex) {
                    ex.printStackTrace();
                    System.out.println("Fail to read DATABASE_MAXCONNECTION, use default value = " + maxConnection);
                }
                try {
                    maxTimeToWait   = Integer.parseInt(res.getString("MAX_TIME_TO_WAIT").trim());
                } catch (Exception ex) {
                    ex.printStackTrace();
                    System.out.println("Fail to read MAX_TIME_TO_WAIT, use default value = " + maxTimeToWait);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("net.myvietnam.db.DBOptions: Can't read the properties file: '" + OPTION_FILE_NAME + ".properties'. Make sure the file is in your CLASSPATH");
        }
    }//constructor
}